SystemOrganization addCategory: #'Rizel-Roassal-Views'!
SystemOrganization addCategory: #'Rizel-Roassal-Views-Tests'!

TestCase subclass: #RzVisualizer1DTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer1DTest commentStamp: '<historical>' prior: 0!
A RzVisualizer1DTest is a test class for testing the behavior of RzVisualizer1D!

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:04'!
tearDown 
	""
	window ifNotNilDo: [ :w | w delete].! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testBarWidth
	"
	self new testBarWidth
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			barWidth: 20;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:21'!
testBasic
	"
	self new testBasic
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:12'!
testBasic2
	"
	self new testBasic2
	"
	window := RzVisualizer1D new 
			values: #( 10 67 120 1230 1250);
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testGap
	"
	self new testGap
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			gap: 40;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testHeight
	"
	self new testHeight
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			height: 300;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testLabel
	"
	self new testLabel
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			label: [ :model | 'x'];
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:21'!
testOwner
	"
	self new testPadding
	"
	|viz|
	viz  := RzVisualizer1D owner: 3.
	window := viz
				values: #( 10 20 30 40 10);
				padding: 100;
				visualize.
				
	self assert: (viz owner = 3).! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:19'!
testPadding
	"
	self new testPadding
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			padding: 100;
			visualize.! !

TestCase subclass: #RzVisualizer2DTest
	instanceVariableNames: 'resultSet xs ys window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:04'!
tearDown
	window ifNotNilDo: [:w| w delete.]! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:30'!
testBasic
	"
	self new testBasic
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x+y ];
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:03'!
testColor
	"
	self new testColor
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						color: Color blue;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 21:05'!
testColor2
	"
	self new testColor2
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 0);
						value: [ :x :y | [x / y] on: Error do:[ nil ] ];
						color: Color blue;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:03'!
testFactor
	"
	self new testFactor
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						factor: 50;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:02'!
testGap
	"
	self new testGap
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						gap: 50;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:11'!
testLabels
	"
	self new testLabels
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						padding: 100;
						yLabel:[ :number| 'long long text'];
						xLabel:[ :number| 'text'];
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:00'!
testPadding
	"
	self new testPadding
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						padding: 100;
						yLabel:[ :number| 'long long text'];
						visualize.! !

Object subclass: #RzRect
	instanceVariableNames: 'x y width height color model last borderColor text selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzRect methodsFor: 'comparing' stamp: ''!
= t1 
	^ model = t1 model! !

!RzRect methodsFor: 'accessing' stamp: ''!
borderColor
	^ borderColor! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:17'!
borderColor: aColor
	borderColor := aColor! !

!RzRect methodsFor: 'accessing' stamp: ''!
color
	^ color! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:17'!
color: aColor
	color := aColor! !

!RzRect methodsFor: 'accessing' stamp: ''!
hasLast
	^ last notNil! !

!RzRect methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:17'!
height: aNumber 
	height := aNumber! !

!RzRect methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	text := [:t1 | t1 asString].
	x := 0.
	y := 0.
	width := 5.
	height := 5.
	model := ''.
	color := Color white.
	borderColor := Color black.
	selected := false! !

!RzRect methodsFor: 'accessing' stamp: ''!
last
	^ last! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:17'!
last: anObject
	last := anObject! !

!RzRect methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:17'!
model: anObject
	model := anObject! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
printOn: aStream
	aStream
		nextPutAll: (text value: model)! !

!RzRect methodsFor: 'accessing' stamp: ''!
printString
	^ text value: model! !

!RzRect methodsFor: 'accessing' stamp: ''!
selected
	^ selected! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
selected: aBoolean
	selected := aBoolean! !

!RzRect methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
text: aString
	text := aString! !

!RzRect methodsFor: 'accessing' stamp: ''!
width
	^ width! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
width: aNumber
	width := aNumber! !

!RzRect methodsFor: 'accessing' stamp: ''!
x
	^ x! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
x: aNumber
	x := aNumber! !

!RzRect methodsFor: 'accessing' stamp: ''!
y
	^ y! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
y: aNumber
	y := aNumber! !

Object subclass: #RzVisualizer
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer class methodsFor: 'factory' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizer methodsFor: 'rizel' stamp: ''!
applyLayoutIn: t1 
	t1 scatterPlotLayout x: #x;
		 y: #y! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:18'!
draw: rect in: view 
	self
		draw: rect
		in: view
		forIt: []! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:19'!
draw: rect in: view forIt: aBlock 
	view shape rectangle width: rect width;
		 height: rect height;
		 fillColor: rect color;
		 borderColor: rect borderColor.
	view node: rect forIt: aBlock.
	self applyLayoutIn: view.! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 00:20'!
drawLabel: aString at: point in: view
	view label
		text: [:model | aString].
	view node: (RzRect new x: point x;
			 y: point y).
	self applyLayoutIn: view! !

!RzVisualizer methodsFor: 'accessing' stamp: ''!
owner
	^ owner! !

!RzVisualizer methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:20'!
owner: anObject
	owner := anObject! !

!RzVisualizer methodsFor: 'visualization' stamp: 'JuanPabloSandovalA 8/19/2012 00:20'!
visualize
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeOn: view.
	^ view open.! !

RzVisualizer subclass: #RzVisualizer1D
	instanceVariableNames: 'label gap values padding height barWidth factor y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:22'!
barWidth: aNumber
	barWidth := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:22'!
gap: aNumber
	gap := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:22'!
height: aNumber
	height := aNumber! !

!RzVisualizer1D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	factor := 2.
	gap := 40.
	padding := 50.
	height := 200.
	label := [:t1 | t1 printString].
	barWidth := 10.
	y := [:t1 | t1]! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:22'!
label: aString
	label := aString! !

!RzVisualizer1D methodsFor: 'util' stamp: 'JuanPabloSandovalA 8/19/2012 00:23'!
minValue: aBlock in: aCollection 
	| min |
	min := aCollection maxValue: aBlock.
	values
		do: [:t5 | min := (aBlock value: t5)
						min: min].
	^ min! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:23'!
padding: aNumber
	padding := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 12:25'!
value: aBlock
	y := aBlock.! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:24'!
values: aCollection 
	values := aCollection! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalA 8/19/2012 00:26'!
visualizeBarsOn: view
	| min max diff delta xo |
	min := self minValue: y in: values.
	max := values maxValue: y.
	diff := max - min.
	delta := max = min
				ifTrue: [self height]
				ifFalse: [self height / diff].
	xo := gap.
	values
		do: [:t8 | 
			| t9 |
			t9 := y value: t8.
			self draw: (RzRect new x: xo;
					 y: (self height - (t9 - min * delta)) asInteger;
					 model: t8;
					 color: Color blue;
					 width: barWidth;
					 height: (t9 - min * delta) asInteger) in: view.
			self
				drawLabel: (label value: t8)
				at: xo @ (self height + 10)
				in: view.
			xo := xo + (barWidth + gap)].
	self applyLayoutIn: view! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalA 8/19/2012 00:26'!
visualizeOn: view 
	self visualizeValuesOn: view.
	self applyLayoutIn: view.! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalA 8/19/2012 00:26'!
visualizeValuesOn: view
	self
		draw: (RzRect new x: padding + factor + gap;
				 y: factor + gap;
				 width: self width;
				 borderColor: Color white;
				 height: self height)
		in: view
		forIt: [self visualizeBarsOn: view].
	self applyLayoutIn: view! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
width
	^ factor + (gap + barWidth) * values size! !

RzVisualizer subclass: #RzVisualizer2D
	instanceVariableNames: 'xValues yValues factor gap value padding xLabel yLabel color root points A B'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
A
	^ A model model! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
B
	^ B model model! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:27'!
color: aColor
	color := aColor! !

!RzVisualizer2D methodsFor: 'rizel' stamp: 'JuanPabloSandovalA 8/19/2012 01:20'!
drawPoint: rect in: view forIt: aBlock 
	view shape rectangle width: rect width;
		 height: rect height;
		 fillColor: rect color;
		 borderWidth: 2;
		 borderColor: [:model |  model selected ifTrue: [Color red] ifFalse: [model borderColor]].
	view interaction
		on: ROMouseClick
		do: [:event | 
			event element model selected: true.
			A ifNil: [A := event element] ifNotNil: [
				B ifNil: [B := event element] ifNotNil: [
					A := B.
					B := event element]].
			points do: [:point | (point getShape: ROBox) borderColor: Color black].
			A ifNotNil: [(A getShape: ROBox) borderColor: Color blue].
			B ifNotNil: [(B getShape: ROBox) borderColor: Color blue].
			root view elementsDo: [:ele | ele signalUpdate]].
	points add: (view node: rect forIt: aBlock).
	self applyLayoutIn: view.! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:30'!
factor: aNumber 
	factor := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:30'!
gap: aNumber
	gap := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
height
	^ yValues size * (factor + gap)! !

!RzVisualizer2D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	gap := 20.
	factor := 25.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	padding := 50.
	color := Color red.
	xLabel := [:t1 | t1 printString].
	yLabel := [:t1 | t1 printString].
	points := OrderedCollection new! !

!RzVisualizer2D methodsFor: 'util' stamp: ''!
max
	| t1 |
	t1 := 0.
	xValues
		do: [:t3 | yValues
				do: [:t4 | (value value: t3 value: t4)
						ifNotNilDo: [:t5 | t1 := t5 max: t1]]].
	^ t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:30'!
padding: aNumber
	padding := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:31'!
value: aBlock
	value := aBlock! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 01:11'!
visualizeOn: view
	root := view.
	self
		draw: (RzRect new x: padding + gap;
				 y: gap;
				 borderColor: Color white;
				 width: self height + gap;
				 height: self width + padding + gap)
		in: view
		forIt: [
			self visualizeXAxisOn: view.
			self visualizeYAxisOn: view.
			self visualizeValuesOn: view.
			self applyLayoutIn: view.].! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 01:08'!
visualizePointsOn: view
	| colors xo yo |
	colors := Color white mix: color shades: 101.
	yo := gap // 2.
	yValues
		do: [:yv | 
			| max |
			max := ((xValues
						collect: [:t8 | value value: t8 value: yv])
						select: [:t8 | t8 notNil])
						maxValue: #yourself.
			max := max isZero
						ifTrue: [1]
						ifFalse: [max].
			xo := gap // 2.
			xValues
				do: [:xv | 
					| val col |
					val := value value: xv value: yv.
					col := val ifNil: [Color gray]
							   ifNotNil: [colors at: (val * 100 / max + 1) asInteger].
					self
						drawPoint: (RzRect new x: xo;
								 y: yo;
								 model: RzVector <== xv + yv;
								 color: col;
								 width: factor;
								 height: factor)
						in: view
						forIt: [].
					xo := xo + factor + gap].
			yo := yo + factor + gap].
	self applyLayoutIn: view.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 01:11'!
visualizeValuesOn: view

	self
		draw: (RzRect new x: padding + gap;
				 y: gap;
				 borderColor: Color white;
				 width: (self width);
				 height: (self height); yourself)
		in: view
		forIt: [self visualizePointsOn: view.
			    self applyLayoutIn: view.].! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 00:38'!
visualizeXAxisOn: view
	| yo xo |
	xo := padding + gap + (gap // 2).
	yo := gap + self height + (gap // 2).
	xValues
		do: [:xv | 
			self
				drawLabel: (xLabel value: xv)
				at: xo @ yo
				in: view.
			xo := xo + (factor + gap)].
	self applyLayoutIn: view.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 01:05'!
visualizeYAxisOn: view
	| xo yo |
	xo := gap.
	yo := gap + (gap // 2).
	yValues
		do: [:t5 | 
			self
				drawLabel: (yLabel value: t5)
				at: xo @ yo
				in: view.
			yo := yo + (factor + gap)].
	self applyLayoutIn: view.! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
width
	^ xValues size * (factor + gap)! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:40'!
xLabel: aBlock
	xLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:40'!
xValues: aBlock
	xValues := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:40'!
yLabel: aBlock
	yLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:40'!
yValues: aBlock
	yValues := aBlock! !

RzVisualizer subclass: #RzVisualizerMerge
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerMerge class methodsFor: 'factory' stamp: ''!
on: t1 
	| t2 |
	t2 := self new.
	t2 profile: t1.
	^ t2! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 8/19/2012 00:42'!
borderColorForMethod: aRzMethod
	aRzMethod hasDifferentByteCode
		ifTrue: [^ Color red].
	^ Color gray! !

!RzVisualizerMerge methodsFor: 'morph' stamp: 'JuanPabloSandovalA 8/19/2012 00:42'!
browseMethod: aRzMethod 
	| aCode bCode |
	aCode := aRzMethod
				property: #copySourceCode
				from: #old
				ifAbsent: [''].
	bCode := aRzMethod
				property: #copySourceCode
				from: #new
				ifAbsent: [''].
	((DiffMorph from: aCode to: bCode)
		extent: 200 @ 200) newWindow open! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 8/19/2012 00:43'!
colorForMethod: aRzMethod 
	| aTime bTime |
	aTime := aRzMethod
				property: #executionTime
				from: #old
				ifAbsent: [0].
	bTime := aRzMethod
				property: #executionTime
				from: #new
				ifAbsent: [0].
	aRzMethod wasDeleted ifTrue: [^ Color gray].
	aRzMethod isNew ifTrue: [^ Color yellow].
	bTime > aTime ifTrue: [^ Color red].
	bTime < aTime ifTrue: [^ Color green].
	^ Color white! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 8/19/2012 00:44'!
heightForMethod: aRzMethod 
	| aTime bTime |
	aTime := aRzMethod
				property: #executionTime
				from: #old
				ifAbsent: [0].
	bTime := aRzMethod
				property: #executionTime
				from: #new
				ifAbsent: [0].
	Transcript show: aTime asString , ' - ' , bTime asString;
		 cr.
	^ (bTime > aTime
		ifTrue: [bTime - aTime]
		ifFalse: [0])
		+ 5! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: ''!
profile
	^ profile! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 8/19/2012 00:44'!
profile: rzProfile
	profile := rzProfile! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 00:45'!
visualizeClasses: rzProfile in: view 
	view shape rectangle withoutBorder.
	view
		nodes: (rzProfile classes
				select: [:t3 | ('* class' match: t3 className) not])
		forEach: [:cls | 
			view
				node: 'methods'
				forIt: [self visualizeMethods: cls in: view].
			view shape label.
			view node: cls className.
			view verticalLineLayout].
	view horizontalLineLayout! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 00:47'!
visualizeMethods: rzClass in: view 
	view shape rectangle
		width: [:mtd | self widthForMethod: mtd];
		height: [:mtd | self heightForMethod: mtd];
		color: [:mtd | self colorForMethod: mtd];
		borderColor: [:mtd | self borderColorForMethod: mtd].
	view interaction
		item: 'browse code'
		action: [:t3 | self browseMethod: t3].
	view nodes: rzClass allMethods.
	view
		edges: rzClass allMethods
		from: #yourself
		toAll: [:mtd | mtd callingMethods].
	view treeLayout.! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalA 8/19/2012 00:47'!
visualizeOn: view
	self visualizeMethods: profile in: view! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 8/19/2012 00:47'!
widthForMethod: rzMethod 
	| ane bne |
	ane := rzMethod
				property: #numberOfExecutions
				from: #old
				ifAbsent: [0].
	bne := rzMethod
				property: #numberOfExecutions
				from: #new
				ifAbsent: [0].
	^ (bne > ane
		ifTrue: [bne - ane]
		ifFalse: [0])
		+ 5! !

Object subclass: #RzVisualizerSelector
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerSelector class methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/19/2012 00:47'!
owner: anObject
	owner := anObject! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/19/2012 00:48'!
v1D
	| viz |
	viz := RzVisualizer1D owner: owner.
	owner visualizer: viz.
	^ viz! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 8/19/2012 00:48'!
v2D
	| viz |
	viz := RzVisualizer2D owner: owner.
	owner visualizer: viz.
	^ viz! !
